unit dm_main;

interface

uses
  SysUtils, Classes, IBQuery, DB, IBCustomDataSet, IBTable, IBDatabase, Dialogs,
  Controls, IBUpdateSQL;

const
  csMainSQL: string = 'select SFT_ID, SFT_TITLE, CMP.CMP_ID, CMP_TITLE, SFT_YEAR, FLD.FLD_ID, FLD_TITLE, CAR.CAR_ID, CAR_NAME, CRT.CRT_ID, CRT_NAME, DESCRIPTION, KEYWORDS ' +
    'from SOFTWARE SFT left join COMPANY CMP on (SFT.CMP_ID = CMP.CMP_ID) ' +
    'left join "FIELD" FLD on (SFT.fld_id = FLD.FLD_ID) ' +
    'left join CARIER CAR on (SFT.car_id = CAR.CAR_ID) ' +
    'left join CARIER_TYPE CRT on (CAR.crt_id = CRT.crt_id)';


type
  TDMMain = class(TDataModule)
    ibdMain: TIBDatabase;
    trMain: TIBTransaction;
    ibtCompany: TIBTable;
    ibtCompanyCMP_ID: TIntegerField;
    ibtCompanyCMP_TITLE: TIBStringField;
    ibqMain: TIBQuery;
    dsMain: TDataSource;
    ibqMainSFT_TITLE: TIBStringField;
    ibqMainCMP_TITLE: TIBStringField;
    ibqMainSFT_YEAR: TIntegerField;
    ibqMainFLD_TITLE: TIBStringField;
    ibqMainCAR_NAME: TIBStringField;
    ibqMainCRT_NAME: TIBStringField;
    ibqMainDESCRIPTION: TMemoField;
    ibqMainKEYWORDS: TIBStringField;
    dsCompany: TDataSource;
    trCompany: TIBTransaction;
    ibtField: TIBTable;
    ibtFieldFLD_ID: TIntegerField;
    ibtFieldFLD_TITLE: TIBStringField;
    dsField: TDataSource;
    ibqMainSFT_ID: TIntegerField;
    ibqMainCMP_ID: TIntegerField;
    ibqMainFLD_ID: TIntegerField;
    ibqMainCAR_ID: TIntegerField;
    ibqMainCRT_ID: TIntegerField;
    ibuMain: TIBUpdateSQL;
    trField: TIBTransaction;
    ibqCarier: TIBQuery;
    ibtCarierType: TIBTable;
    trCarierType: TIBTransaction;
    dsCarierType: TDataSource;
    ibtCarierTypeCRT_ID: TIntegerField;
    ibtCarierTypeCRT_NAME: TIBStringField;
    trCarier: TIBTransaction;
    ibqCarierCAR_ID: TIntegerField;
    ibqCarierCAR_NAME: TIBStringField;
    ibqCarierCRT_ID: TIntegerField;
    ibqCarierCRT_NAME: TIBStringField;
    dsCarier: TDataSource;
    ibuCarier: TIBUpdateSQL;
    procedure ibtCompanyAfterInsert(DataSet: TDataSet);
    procedure ibtAfterDelete(DataSet: TDataSet);
    procedure ibtBeforeDelete(DataSet: TDataSet);
    procedure ibtFieldAfterInsert(DataSet: TDataSet);
    procedure ibqMainBeforeOpen(DataSet: TDataSet);
    procedure ibtCarierTypeAfterInsert(DataSet: TDataSet);
    procedure ibqCarierAfterInsert(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure InsertRecord (AField: TField);
    procedure ReopenTable (DataSet: TIbCustomDataSet);
    procedure DeleteRecord (DataSet: TDataSet);
  end;

var
  DMMain: TDMMain;
  sSortCondition: string;

procedure Banzai;

implementation

uses u_refeditdlg, u_careditdlg;

{$R *.dfm}

procedure Banzai;
begin
  sSortCondition := 'SFT.SFT_TITLE';
  with DMMain do begin
    ibdMain.DatabaseName := 'localhost:' + GetCurrentDir + '\DATA.FDB';
    ibdMain.Open;
    ibqMain.Open;
    ibtCompany.Open;
    ibtField.Open;
    ibtCarierType.Open;
    ibqCarier.Open;
  end;
end;

procedure TDMMain.InsertRecord(AField: TField);
var
  AValue: string;
begin
  with AField do begin
    AValue := AField.AsString;
    if GetRecordValue (DisplayLabel, AValue) then begin
      AField.AsString := AValue;
      AField.DataSet.Post;
      ReopenTable (AField.DataSet as TIBCustomDataSet);
    end else
      AField.DataSet.Cancel;
  end;
end;

procedure TDMMain.ibtCompanyAfterInsert(DataSet: TDataSet);
begin
  InsertRecord (ibtCompanyCMP_TITLE);
end;

procedure TDMMain.DeleteRecord (DataSet: TDataSet);
begin
  if MessageDlg (' ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    DataSet.Delete;
    ReopenTable (DataSet as TIbCustomDataSet);
  end else
    DataSet.Cancel;
end;

procedure TDMMain.ReopenTable(DataSet: TIbCustomDataSet);
var
  bm: integer;
begin
  with DataSet do begin
    if not DataSet.Fields [0].IsNull then
      bm := DataSet.Fields [0].AsInteger
    else
      bm := -1;
    Transaction.Commit;
    Transaction.StartTransaction;
    Active := TRUE;
    if bm <> -1 then
      DataSet.Locate(DataSet.Fields [0].FieldName, bm, []);
  end;
end;

procedure TDMMain.ibtAfterDelete(DataSet: TDataSet);
begin
  ReopenTable(DataSet as TIBCustomDataSet);
end;

procedure TDMMain.ibtBeforeDelete(DataSet: TDataSet);
begin
  if MessageDlg (' ?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
    Abort;
end;

procedure TDMMain.ibtFieldAfterInsert(DataSet: TDataSet);
begin
  InsertRecord (ibtFieldFLD_TITLE);
end;

procedure TDMMain.ibqMainBeforeOpen(DataSet: TDataSet);
begin
  ibqMain.SQL.Text := csMainSql + ' ORDER BY ' + sSortCondition;
end;

procedure TDMMain.ibtCarierTypeAfterInsert(DataSet: TDataSet);
begin
  InsertRecord (ibtCarierTypeCRT_NAME);
end;

procedure TDMMain.ibqCarierAfterInsert(DataSet: TDataSet);
begin
  if FormCarEditDlg.ShowModal = mrOk then begin
    DataSet.Post;
    ReopenTable (DataSet as TIbQuery)
  end else
    DataSet.Cancel;
end;

end.
