unit u_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, ComCtrls, ActnCtrls, ToolWin, ActnMan,
  ActnMenus, XPStyleActnCtrls, ActnList, ImgList, ExtCtrls, DBCtrls;

type
  TFormMain = class(TForm)
    ActionManager1: TActionManager;
    ActionMainMenuBar1: TActionMainMenuBar;
    ActionToolBar1: TActionToolBar;
    StatusBar1: TStatusBar;
    DBGrid1: TDBGrid;
    ActionRefCompany: TAction;
    ImageList1: TImageList;
    ActionReField: TAction;
    ActionCatInsert: TAction;
    ActionRefCarierType: TAction;
    ActionCatExit: TAction;
    ActionRefCarier: TAction;
    ActionCatEdit: TAction;
    ActionCatDelete: TAction;
    ActionSortTitle: TAction;
    ActionSortCompany: TAction;
    ActionSortYear: TAction;
    ActionSortField: TAction;
    ActionSortCarier: TAction;
    ActionSortCarierType: TAction;
    procedure ActionRefCompanyExecute(Sender: TObject);
    procedure ActionReFieldExecute(Sender: TObject);
    procedure ActionCatInsertExecute(Sender: TObject);
    procedure ActionRefCarierTypeExecute(Sender: TObject);
    procedure ActionCatExitExecute(Sender: TObject);
    procedure ActionRefCarierExecute(Sender: TObject);
    procedure ActionCatEditExecute(Sender: TObject);
    procedure ActionCatDeleteExecute(Sender: TObject);
    procedure ActionSortTitleExecute(Sender: TObject);
    procedure ActionSortCompanyExecute(Sender: TObject);
    procedure ActionSortYearExecute(Sender: TObject);
    procedure ActionSortFieldExecute(Sender: TObject);
    procedure ActionSortCarierExecute(Sender: TObject);
    procedure ActionSortCarierTypeExecute(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses dm_main, u_refdlg, u_maineditdlg;

{$R *.dfm}

procedure TFormMain.ActionRefCompanyExecute(Sender: TObject);
begin
  Choose (' ', DMMain.dsCompany);
end;

procedure TFormMain.ActionReFieldExecute(Sender: TObject);
begin
  Choose (' ', DMMain.dsField);
end;

procedure TFormMain.ActionCatInsertExecute(Sender: TObject);
begin
  with DMMain do begin
    ibqMain.Insert;
    if FormMainEditDlg.ShowModal = mrOk then begin
      try
        ibqMain.Post;
        ReopenTable (ibqMain);
      except
        on E: Exception do
          MessageDlg ('   : ' + #13 +
            E.Message, mtError, [mbOk], 0);
      end;
    end else
      ibqMain.Cancel;
  end;
end;

procedure TFormMain.ActionRefCarierTypeExecute(Sender: TObject);
begin
  Choose ('  ', DMMain.dsCarierType);
end;

procedure TFormMain.ActionCatExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.ActionRefCarierExecute(Sender: TObject);
begin
  Choose (' ', DMMain.dsCarier);
end;

procedure TFormMain.ActionCatEditExecute(Sender: TObject);
begin
  with DMMain do begin
    ibqMain.Edit;
    if FormMainEditDlg.ShowModal = mrOk then begin
      try
        ibqMain.Post;
        ReopenTable (ibqMain);
      except
        on E: Exception do
          MessageDlg ('   : ' + #13 +
            E.Message, mtError, [mbOk], 0);
      end;
    end else
      ibqMain.Cancel;
  end;
end;

procedure TFormMain.ActionCatDeleteExecute(Sender: TObject);
begin
  DMMain.DeleteRecord(DMMain.ibqMain);
end;

procedure TFormMain.ActionSortTitleExecute(Sender: TObject);
begin
  sSortCondition := 'SFT.SFT_TITLE';
  DMMain.ReopenTable(DMMain.ibqMain);
end;

procedure TFormMain.ActionSortCompanyExecute(Sender: TObject);
begin
  sSortCondition := 'CMP.CMP_TITLE';
  DMMain.ReopenTable(DMMain.ibqMain);
end;

procedure TFormMain.ActionSortYearExecute(Sender: TObject);
begin
  sSortCondition := 'SFT.SFT_YEAR';
  DMMain.ReopenTable(DMMain.ibqMain);
end;

procedure TFormMain.ActionSortFieldExecute(Sender: TObject);
begin
  sSortCondition := 'FLD.FLD_TITLE';
  DMMain.ReopenTable(DMMain.ibqMain);
end;

procedure TFormMain.ActionSortCarierExecute(Sender: TObject);
begin
  sSortCondition := 'CAR.CAR_NAME';
  DMMain.ReopenTable(DMMain.ibqMain);
end;

procedure TFormMain.ActionSortCarierTypeExecute(Sender: TObject);
begin
  sSortCondition := 'CRT.CRT_NAME';
  DMMain.ReopenTable(DMMain.ibqMain);
end;

procedure TFormMain.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  r: TRect;
begin
  r := Rect;
  r.Right := r.Right + 1;
  r.Bottom := r.Bottom + 1;
  with DbGrid1.Canvas do begin
    if Odd (Column.Field.DataSet.RecNo) then
      Brush.Color := $009D9D9D
    else
      Brush.Color := clSilver;
    if gdFocused in State then
      Brush.Color := clNavy;
    FillRect (r);
    if gdFocused in State then
      Frame3D (DbGrid1.Canvas, r, clBlack, clWhite, 1)
    else
      Frame3D (DbGrid1.Canvas, r, clWhite, clBlack, 1);
    TextRect (r, r.Left + 1, r.Top + 2, Column.Field.AsString);
  end;
end;

end.
